/*
 * Kepek.java (fake!)
 * kamu az eNTitanok.gfx.Kepek helyett, a prototpushoz
 * by pts@fazekas.hu at Sun Apr 22 17:44:56 CEST 2001
 * tovbbi doksi: a README-ben s e file legkls class-nak fejkommentjben
 *
 * Kincskeres Kisgmbc (C) Early May 2001 by eNTitnok (Rv Szilvia,
 * Szab Pter <pts@inf.bme.hu>, Szurdi Mikls, Weizengruber Attila).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or   
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package eNTitanok.fake;

/**
 * Kamu az eNTitanok.gfx.Kepek helyett, a prototpushoz.
 */
public class Kepek {
  /**
   * A f (toplevel) AWT komponenst lltja be. Ez legtbbszr Applet vagy
   * Frame tpus. (A kamu implementci trzse res.)
   */
  public static void setMainComponent(Object mainComponent_) {}

  /**
   * A kpfile-ok aszinkron betltsnek elindtsrt, s a folyamatben lev
   * betltsek megvrsrt felel.
   */
  public static class Kepbetolto {
    public Kepbetolto() {}
    /**
     * A megadott nev kp betltst kezdemnyezi. Azonnal visszatr egy
     * :Kp objektummal, ami ekkor mg res, s csak ksbb tltdik bele a
     * valdi kp.
     */
    public Kep betolt(String filenev) { return new Kep(); }
    /**
     * Megvrja, amg az sszes folyamatben lev betlts befejezdik.
     */
    public void mind_meglegyen() {}
    /**
     * A megadott nev kpett kitrli sajt cache-bl.
     */
    public void elfelejt(String filenev) {}
  } /// class Kepbetolto

  public static class Kep {
    public Kep() {}
    /**
     * Betlts utni inicializlst hajt vgre a kpen. A kamu implementci
     * trzse res.
     */
    public Kep initi(Sdpts sd, int bx1, int by1, int arnyeka) {
      return this;
    }
    /**
     * Betlts utni inicializlst hajt vgre a kpen. A kamu implementci
     * trzse res.
     */
    public Kep initi(Sdpts sd, int bx1, int by1) {
      return this;
    }
    /**
     * @return pontosan akkor `true', ha `this' tkzik `masik'-kal, ha
     * `masik'-nak `this'-tl mrt tvolsga <I>(dx,dy)</I>. A kamu
     * implementci mindkt kpet egy 23x23-as teli ngyzetnek tekinti.
     */
    public boolean utkozik_e(Kep masik, int dx, int dy) {
      return Math.abs(dx)<23 && Math.abs(dy)<23;
    }
    /**
     * A kp filenevt adja vissza. A kamu implementciban mindig ugyanazt.
     */
    public String getFilenev() { return "__fake.gif"; }
    /**
     * Kirajzolja magt a megadott Graphics objektumra (x,y) pozcin. A kamu
     * implementci trzse res.
     */
    public void rarajzol(Object g, int x, int y) { }
    /**
     * Kirajzolja az rnykt a sajt :Sdpts megjelentjre az (x,y) pozcin.
     * A kamu implementci trzse res.
     */
    public void felrajzol_arnyek(int x, int y) { }
    /**
     * Kirajzolja magt a sajt :Sdpts megjelentjre az (x,y) pozcin.
     * A kamu implementci trzse res.
     */
    public void felrajzol_kep(int x, int y) { }
    /**
     * Trli a pixel cache-t. A kamu implementciban nincs pixel cache (s
     * egyelre nem is dokumentljuk, mi az), gy a trzse res.
     */
    public void pixelt_felejt() {}
  } /// class Kep

  /**
   * Egy hromrteg, tglalap alak, memriabeli rajztblt reprezentl,
   * melynek tartalma igny szerint megjelenthet a kpernyn. A kamu
   * implementci nem rajzol semmit sehov, a metdusok trzse res.
   */
  public static class Sdpts {
    public Sdpts() {}
    /**
     * Trli a cache-t. A kamu implementciban nincs cache (s
     * egyelre nem is dokumentljuk, mi az), gy a trzse res.
     */
    public void dirtyClear() {}
  }

  /**
   * Egy olyan AWT komponens (Canvas), melyre egy `Sdpts'-en keresztl lehet
   * rajzolni, s a memriban lev llapotot idnknt a kpernyre visszk.
   * A kamu implementciban a metdusok trzse res.
   */
  public static class SdRajzolo {
    private Sdpts sd;
    public Sdpts getSd() { return sd; }
    public void atmeretez(int w, int h) {}
    public void init_sd() { sd=new Sdpts(); }
    public void paintMost() {}
    public void repaint() {}
  } /// class SdRajzolo
} /// class Kepek
